=== debian/changelog ===
otb (8.1.1+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Add patch to fix version detection from release notes.
  * Update symbols for amd64.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 13 Jan 2023 16:40:55 +0100

otb (8.1.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 30 Nov 2022 05:19:42 +0100

otb (8.1.0+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.6.1, no changes.
  * Drop lena files from Files-Excluded, removed upstream.
  * Drop libopenthreads-dev from (build) dependencies.
  * Add Rules-Requires-Root to control file.
  * Update symbols for amd64.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 28 Nov 2022 20:31:50 +0100
